<template>
  <div class="">
    <div class="flex items-center">
      <SearchSettings @search="search" hint="Поиск производится по названию статуса" style="width:calc(100% - 200px)" />
      <q-btn @click="addTask" color="green" label="Добавить" icon-right="add" dense class="h-10 ml-4"/>
    </div>
    <q-spinner-gears
        v-if="!task.length"
        color="primary"
        size="8em"
        class="mx-auto mt-12"
    />

    <q-list>
      <div class="flex">
        <q-chip v-for="(item, index) in task" :key="item._id" :label="item.name">
          <q-popup-edit v-model="item.name" v-slot="scope" >
            <q-input v-model="scope.value" dense autofocus counter />
            <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="updateTask(item, index, scope.value)"/>
          </q-popup-edit>

          <q-icon name="delete" size="sm" class="ml-1 cursor-pointer" @click.stop="deleteTask(item._id, index)"/>
        </q-chip>
      </div>
    </q-list>
  </div>
</template>

<script>
import api from "../../API/api";
import {ref} from "vue";
import SearchSettings from "./Search-settings.vue";
import {useDebounce} from "../../components/useDebounce";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "Task-settings",
  components: {SearchSettings},
  setup () {
    const task = ref([])
    api.getTasks()
      .then(r => {
        task.value = r.data.tasks
        stringOptions = r.data.tasks
      })
    function search (value) {
      const needle = value.toLocaleString().toLocaleLowerCase()
      task.value = stringOptions.filter(v => v.name.toLocaleLowerCase().indexOf(needle) > -1)
    }
    async function addTask () {
      const newStatus = {name: 'Новая задача'}
      await api.addTask(newStatus)
          .then(r => {
            newStatus._id = r.data._id
            task.value.unshift(newStatus)
          })
    }
    async function updateTask (item, index, value) {
      task.value[index].name = value
      await useDebounce(api.changeTask({_id: item._id, name: value}), 300)
    }
    async function deleteTask (_id, index) {
      await api.deleteTask({_id})
          .then(() => task.value.splice(index, 1))
    }
    return {
      task,
      addTask,
      updateTask,
      deleteTask,
      search,
    }
  }
}
</script>

<style scoped>

</style>